#!/usr/bin/env python
# coding: utf-8

# In[127]:


import numpy as np
import scipy.optimize as spo
from matplotlib import pyplot as plt   
plt.rcParams['axes.grid'] = True       #Paramètre esthétique, peut être retiré
plt.rcParams['savefig.format'] = 'png' #On peut sélectionner pdf si on aime les images vectorielles


# In[128]:


#Données = np.transpose(np.loadtxt("C:\\Users\\dupuy\\Desktop\\Texte.txt"))
#Données


# In[178]:


#x = Données[0]
#y = Données[1]
#ux= Données[2]
#uy= Données[3]


Concentration = np.array([])*10**3
Conductivité = np.array([])/10
uConcentration = np.array([])
uConductivité= np.array([])

xf = Conductivité/(34.9+4.1)
uxf = uConductivité/(34.9+4.1)

Qeq = (xf**2)/(Concentration - xf)
uQeq = Qeq * ((2*uxf/xf)**2+((uConcentration**2 + uxf**2)/(Concentration - xf)**2))**0.5

x = Concentration 
y = Qeq 
ux = uConcentration 
uy = uQeq 


#Concentrationexp =  np.array([0.1748])*10**3
#Conductivitéexp = np.array([595])/10
#uConcentrationexp = np.array([0.56])
#uConductivitéexp = np.array([1])

Concentrationexp =  np.array([])*10**3
Conductivitéexp = np.array([])/10  #ici en µs/cm
uConcentrationexp = np.array([])
uConductivitéexp = np.array([])  #là en µS/cm

xfexp = Conductivitéexp/(34.9+4.1)
uxfexp = uConductivitéexp/(34.9+4.1)

Qeqexp = (xfexp**2)/(Concentrationexp - xfexp)
uQeqexp = Qeqexp * ((2*uxfexp/xfexp)**2+((uConcentrationexp**2 + uxfexp**2)/(Concentrationexp - xfexp))**2)**0.5

xexp = Concentrationexp
yexp = Qeqexp
uxexp = uConcentrationexp 
uyexp = uQeqexp

x = np.concatenate((x,xexp))/1000
y = np.concatenate((y,yexp))/1000
ux = np.concatenate((ux,uxexp))/1000
uy = np.concatenate((uy,uyexp))/1000

print(x,y)


# In[179]:


#def f(x,p):
#    a,b = p
#    return a*x+b

#def Dx_f(x,p):
#    a,b = p
#    return a

#def residual(p,y,x):
#    return (y-f(x,p))/np.sqrt(uy**2 +(Dx_f(x,p)*ux)**2)


# In[180]:


def f(x,p):
    a = p
    return a 

def Dx_f(x,p):
    a = p
    return 0

def residual(p,y,x):
    return (y-f(x,p))/np.sqrt(uy**2 +(Dx_f(x,p)*ux)**2)


# In[181]:


p0 = np.array([0.1])

result = spo.leastsq(residual,p0,args=(y,x), full_output=True)
popt = result[0]
pcov = result[1]
upopt = np.sqrt(np.abs(np.diagonal(pcov)))


# In[182]:


print('Quotient moyen = ' + str(round(popt[0],8)) + ' ± ' + str(round(upopt[0],10)))


# In[192]:


plt.figure(figsize=(24,12))
x_mod = np.linspace(x[0],x[len(x)-2],1000)
y_mod = np.full(1000, popt)
plt.plot(x_mod,y_mod,label='quotient réactionnel moyen $\\overline{Q_r} =$' + str(round(popt[0],8)) + ' ± ' + str(round(upopt[0],8)) , color = 'blue', linestyle= '-')
plt.errorbar(x,y,xerr=ux,yerr=uy,marker='+', color = 'red', linestyle= '',label='Points pris en préparation')
plt.errorbar(xexp/1000,yexp/1000,xerr=uxexp/1000,yerr=uyexp/1000,marker='+', color = 'green', linestyle= '',label='Points pris en direct')
plt.ylabel('$Q_{r,eq} (\\times 10^5) $',fontsize=32)
plt.xlabel('Concentration [mol/L]',fontsize=32)
plt.yticks(fontsize=32)
plt.xticks(fontsize=32)
plt.xlim(0.01,0.99)
plt.ylim(0,1.49*10**(-5))
plt.legend(loc='lower left',fontsize=25)
#plt.text(4, 2.1, 'Pente a = ' + str(round(popt[0],10)) + ' ± ' + str(round(upopt[0],10)) + ' unité',fontsize=16)
#plt.text(4, 1.4, 'Ordonnée à l\'origine = ' + str(round(popt[1],10)) + ' ± ' + str(round(upopt[1],10)) + ' unité',fontsize=16)
plt.show()


# In[ ]:





# In[ ]:




